{-# LANGUAGE FunctionalDependencies #-}
module Types.FunctionIO
  ( IsFunctionIO(..)
  ) where

import Types.Value (Valuable)

import Language.Haskell.TH.Syntax (Lift)


class (Show f, Lift f, Valuable a, Valuable b) => IsFunctionIO f a b | f -> a b where
  evalFunctionIO :: f -> a -> IO b
  functionIOTouchesFilesystem :: f -> Bool
