{-# LANGUAGE FunctionalDependencies #-}
module Types.Function
  ( IsFunction(..)
  ) where

import Types.Value (Valuable)

import Language.Haskell.TH.Syntax (Lift)

class (Show f, Lift f, Valuable a, Valuable b) => IsFunction f a b | f -> a b where
  evalFunction :: f -> a -> b
